Debian Bug report logs - #232448
Ada Library Information files must be read-only

version graph

Package: debian-policy; Maintainer for debian-policy is Debian Policy List <debian-policy@lists.debian.org>; Source for debian-policy is src:debian-policy.

Reported by: ludovic@ludovic-brenta.org

Date: Thu, 12 Feb 2004 20:18:02 UTC

Severity: wishlist

Found in version 3.6.1.0

Fixed in version debian-policy/3.9.1.0

Done: Russ Allbery <rra@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Ludovic Brenta <ludovic.brenta@insalien.org>, Debian Policy List <debian-policy@lists.debian.org>:
Bug#232448; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to ludovic.brenta@insalien.org:
New Bug report received and forwarded. Copy sent to Ludovic Brenta <ludovic.brenta@insalien.org>, Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: ludovic.brenta@insalien.org
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: debian-policy: Ada Library Information files must be read-only
Date: Thu, 12 Feb 2004 21:01:03 +0100
Package: debian-policy
Version: 3.6.1.0
Severity: wishlist

The packages gnat, gnat-3.2, gnat-3.3 and several Ada library packages
provide Ada Library Information (*.ali) files to accompany the
compiled (static and shared) libraries.  The Ada compiler requires
these files to be read-only for all users; otherwise, it tries to
recompile the corresponding source files, and fails because it cannot
place the object files in the same directory as the *.ali files.

The Policy should state that all packages that install *.ali files
must ensure they are read-only for all users.  For now, the Ada
packages use post-installation scripts for this, thus bypassing checks
made by lintian and linda.  See bugs #226879 and #227162.

I propose the following addition to Section 8.4 "Development files":

"If the package provides Ada Library Information (*.ali) files for use
with GNAT, these files must be read-only for all users."

For the record, here is a list of directories that contain *.ali
files:

Package                Directory
------------------------------------------------------------------------
gcc-snapshot           /usr/lib/gcc-snapshot/lib/gcc/*-linux/3.4.0/adalib
gnade-dev              /usr/lib/ada/adalib/gnade
gnat                   /usr/lib/gcc-lib/*-linux/2.8.1/adalib
gnat-3.2               /usr/lib/gcc-lib/*-linux/3.2.3/adalib
gnat-3.3               /usr/lib/gcc-lib/*-linux/3.3.3/adalib
gnat-glade	       /usr/lib/ada/adalib/garlic
libasis-3.15p-1-dev    /usr/lib/ada/adalib/asis
libcharles0-dev	       /usr/lib/ada/adalib/charles
libflorist-3.15p-1-dev /usr/lib/ada/adalib/florist
libgtkada2-dev	       /usr/lib/ada/adalib/gtkada2
libxmlada1-dev	       /usr/lib/ada/adalib/xmlada

(on my system this amounts to 7412 *.ali files).

-- System Information:
Debian Release: testing/unstable
Architecture: i386
Kernel: Linux lbrenta 2.4.23-1-686-smp #1 SMP Sun Nov 30 21:55:37 EST 2003 i686
Locale: LANG=fr_FR.UTF-8, LC_CTYPE=fr_FR.UTF-8

-- no debconf information





Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#232448; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to Steve Langasek <vorlon@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #10 received at 232448@bugs.debian.org (full text, mbox):

From: Steve Langasek <vorlon@debian.org>
To: ludovic.brenta@insalien.org, 232448@bugs.debian.org
Subject: Re: Bug#232448: debian-policy: Ada Library Information files must be read-only
Date: Thu, 12 Feb 2004 17:23:25 -0600
[Message part 1 (text/plain, inline)]
On Thu, Feb 12, 2004 at 09:01:03PM +0100, ludovic.brenta@insalien.org wrote:

> The packages gnat, gnat-3.2, gnat-3.3 and several Ada library packages
> provide Ada Library Information (*.ali) files to accompany the
> compiled (static and shared) libraries.  The Ada compiler requires
> these files to be read-only for all users; otherwise, it tries to
> recompile the corresponding source files, and fails because it cannot
> place the object files in the same directory as the *.ali files.

> The Policy should state that all packages that install *.ali files
> must ensure they are read-only for all users.  For now, the Ada
> packages use post-installation scripts for this, thus bypassing checks
> made by lintian and linda.  See bugs #226879 and #227162.

> I propose the following addition to Section 8.4 "Development files":

> "If the package provides Ada Library Information (*.ali) files for use
> with GNAT, these files must be read-only for all users."

I don't see that this is a very good reason for an exception to the
rules on file permissions.  Why can't gnat be fixed so that it doesn't
try to auto-create object files when it shouldn't?

-- 
Steve Langasek
postmodern programmer
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#232448; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to Bill Allombert <allomber@math.u-bordeaux.fr>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #15 received at 232448@bugs.debian.org (full text, mbox):

From: Bill Allombert <allomber@math.u-bordeaux.fr>
To: ludovic.brenta@insalien.org, 232448@bugs.debian.org
Subject: Re: Bug#232448: debian-policy: Ada Library Information files must be read-only
Date: Fri, 13 Feb 2004 01:18:08 +0100
On Thu, Feb 12, 2004 at 09:01:03PM +0100, ludovic.brenta@insalien.org wrote:
> The packages gnat, gnat-3.2, gnat-3.3 and several Ada library packages
> provide Ada Library Information (*.ali) files to accompany the
> compiled (static and shared) libraries.  The Ada compiler requires
> these files to be read-only for all users; otherwise, it tries to
> recompile the corresponding source files, and fails because it cannot
> place the object files in the same directory as the *.ali files.

What do you mean by 'read-only for all users' ? mode 0444 ? 0004 ?

> The Policy should state that all packages that install *.ali files
> must ensure they are read-only for all users.  For now, the Ada
> packages use post-installation scripts for this, thus bypassing checks
> made by lintian and linda.  See bugs #226879 and #227162.

Why do you need to bypass lintian and linda?

lintian and linda checks are advisory only, and you can even add a lintian
override if you feel like it.

It seems a strange use of post-installation scripts.

Cheers,
-- 
Bill. <ballombe@debian.org>

Imagine a large red swirl here. 



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#232448; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to Ludovic Brenta <ludovic.brenta@insalien.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #20 received at 232448@bugs.debian.org (full text, mbox):

From: Ludovic Brenta <ludovic.brenta@insalien.org>
To: Steve Langasek <vorlon@debian.org>
Cc: ludovic.brenta@insalien.org, 232448@bugs.debian.org
Subject: Re: Bug#232448: debian-policy: Ada Library Information files must be read-only
Date: 13 Feb 2004 01:50:02 +0100
Steve Langasek <vorlon@debian.org> writes:

> I don't see that this is a very good reason for an exception to the
> rules on file permissions.  Why can't gnat be fixed so that it doesn't
> try to auto-create object files when it shouldn't?

Because this would break the documented behaviour of GNAT and thus
make Debian incompatible with other distributions:

`-a'
     Consider all files in the make process, even the GNAT internal
     system files (for example, the predefined Ada library files), as
     well as any locked files. Locked files are files whose ALI file is
     write-protected.  By default, `gnatmake' does not check these
     files, because the assumption is that the GNAT internal files are
     properly up to date, and also that any write protected ALI files
     have been properly installed. Note that if there is an
     installation problem, such that one of these files is not up to
     date, it will be properly caught by the binder. [...]

(see http://gcc.gnu.org/onlinedocs/gcc-3.3.2/gnat_ug_unx/Switches-for-gnatmake.html#Switches%20for%20gnatmake)

With Debian packages, the write-protected ALI files have indeed been
properly installed and we want to tell GNAT not to check them for
consistency.  Failing to do this results in useless recompilations and
defeats the purpose of providing precompiled libraries.  (it is
possible to cause these useless recompilations to write to the current
directory instead of the directory where *.ali files are, though).

-- 
Ludovic Brenta.




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#232448; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to Ludovic Brenta <ludovic.brenta@insalien.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #25 received at 232448@bugs.debian.org (full text, mbox):

From: Ludovic Brenta <ludovic.brenta@insalien.org>
To: Bill Allombert <allomber@math.u-bordeaux.fr>
Cc: ludovic.brenta@insalien.org, 232448@bugs.debian.org
Subject: Re: Bug#232448: debian-policy: Ada Library Information files must be read-only
Date: 13 Feb 2004 02:00:23 +0100
Bill Allombert <allomber@math.u-bordeaux.fr> writes:

> What do you mean by 'read-only for all users' ? mode 0444 ? 0004 ?

I mean 0444.

> Why do you need to bypass lintian and linda?
> 
> lintian and linda checks are advisory only, and you can even add a lintian
> override if you feel like it.

As you said, I don't *need* to bypass lintian and linda, but there are
many *.ali files and I wouldn't like to miss an important warning amid
the hundreds of harmless ones.  But I suppose this would be better
discussed in the bugs I filed on linda and lintian themselves.

-- 
Ludovic Brenta.




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#232448; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to Bill Allombert <allomber@math.u-bordeaux.fr>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #30 received at 232448@bugs.debian.org (full text, mbox):

From: Bill Allombert <allomber@math.u-bordeaux.fr>
To: Ludovic Brenta <ludovic.brenta@insalien.org>, 232448@bugs.debian.org
Cc: Steve Langasek <vorlon@debian.org>
Subject: Re: Bug#232448: debian-policy: Ada Library Information files must be read-only
Date: Fri, 13 Feb 2004 02:25:29 +0100
On Fri, Feb 13, 2004 at 01:50:02AM +0100, Ludovic Brenta wrote:
> Steve Langasek <vorlon@debian.org> writes:
> 
> > I don't see that this is a very good reason for an exception to the
> > rules on file permissions.  Why can't gnat be fixed so that it doesn't
> > try to auto-create object files when it shouldn't?
> 
> Because this would break the documented behaviour of GNAT and thus
> make Debian incompatible with other distributions:
> 
> `-a'
>      Consider all files in the make process, even the GNAT internal
>      system files (for example, the predefined Ada library files), as
>      well as any locked files. Locked files are files whose ALI file is
>      write-protected.  By default, `gnatmake' does not check these
>      files, because the assumption is that the GNAT internal files are
>      properly up to date, and also that any write protected ALI files
>      have been properly installed. Note that if there is an
>      installation problem, such that one of these files is not up to
>      date, it will be properly caught by the binder. [...]
> 

There are still some points that are unclear to me:

Why is it not sufficient for the file to be `write-protected' for the
user running gnat instead of all users including root ? Or if it is, why
when running as root cannot it add the compiled files in the same
directory ? If it is not, why not just fix the test ?

Also why can't gnat check if the compiled binary exists instead ?

Cheers,
-- 
Bill. <ballombe@debian.org>

Imagine a large red swirl here. 



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#232448; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to Ludovic Brenta <ludovic.brenta@insalien.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #35 received at 232448@bugs.debian.org (full text, mbox):

From: Ludovic Brenta <ludovic.brenta@insalien.org>
To: Bill Allombert <allomber@math.u-bordeaux.fr>
Cc: Ludovic Brenta <ludovic.brenta@insalien.org>, 232448@bugs.debian.org, Steve Langasek <vorlon@debian.org>
Subject: Re: Bug#232448: debian-policy: Ada Library Information files must be read-only
Date: 13 Feb 2004 03:36:28 +0100
Bill Allombert <allomber@math.u-bordeaux.fr> writes:
> Why is it not sufficient for the file to be `write-protected' for the
> user running gnat instead of all users including root ? Or if it is, why
> when running as root cannot it add the compiled files in the same
> directory ? If it is not, why not just fix the test ?

The file must be 0444, not 0644.  The reason for this is within GNAT
itself; I think it has to do with portability (with Windows, OpenVMS).
If we would change this for Debian, we would become incompatible with
the other platforms and distributions where GNAT runs.

> Also why can't gnat check if the compiled binary exists instead ?

First a little backgrounder on these *.ali files.

Ada has stringent rules (chapter 10 in the [1]Reference Manual) for
program consistency.  These rules (in particular 10.1.4 (5)) basically
guarantee that the final executable consists of object files that are
up-to-date and consistent with the corresponding source files.

GNAT uses Ada Library Information files for this purpose.  For each
object (*.o) file, GNAT also produces a *.ali file that contains lots
of information[2] about the compiler options, timestamp, and even
checksum of the source file.  The *.ali files contain mostly
human-readable text.

Once the object and *.ali files for a library have been produced, GNAT
uses them to compile, bind and link programs that use the library.

* If an object file is present in the same directory as the *.ali
  file, it is linked statically into the final executable.  We do not
  want this; we want the final executable to be linked against the
  shared library instead.  Therefore, Debian packages never include
  the object files, only static and shared libraries, just like C or
  C++ library packages.

* If the *.ali file has permissions different from 0444, or if the
  user passes the `-a' flag, GNAT considers whether or not to
  recompile the corresponding source file.  Since the object file is
  missing, it will always try to recompile the source file.  This
  defeats the purpose of providing precompiled libraries.  We also do
  not want this; therefore we want the *.ali files to have permissions
  0444.

If the user insists on recompiling the library, this is quite easy too
because the *.ali files are in a different directory than the source
files.  The user just has to omit the directory with the *.ali files
in their compilation.  GNAT, not seeing the *.ali files, recompiles
the relevant source files for the library, just like if they were part
of the user's program.  This recompilation occurs in the user's
current directory and does not cause problems with file permissions.

I hope I have made things clearer now.

[1] http://www.adaic.org/standards/95lrm/html/RM-TOC.html
[2] http://gcc.gnu.org/onlinedocs/gcc-3.3.2/gnat_ug_unx/The-Ada-Library-Information-Files.html#The%20Ada%20Library%20Information%20Files

-- 
Ludovic Brenta.




Changed Bug submitter from ludovic.brenta@insalien.org to ludovic@ludovic-brenta.org. Request was from "Ludovic Brenta" <ludovic.brenta@tiscali.be> to control@bugs.debian.org. Full text and rfc822 format available.

Changed Bug title to `Ada Library Information files must be read-only' from `debian-policy: Ada Library Information files must be read-only'. Request was from Russ Allbery <rra@debian.org> to control@bugs.debian.org. (Mon, 17 Mar 2008 05:24:17 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#232448; Package debian-policy. (Sun, 18 Jul 2010 01:45:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Russ Allbery <rra@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. (Sun, 18 Jul 2010 01:45:03 GMT) Full text and rfc822 format available.

Message #44 received at 232448@bugs.debian.org (full text, mbox):

From: Russ Allbery <rra@debian.org>
To: Ludovic Brenta <lbrenta@debian.org>
Cc: 232448@bugs.debian.org
Subject: Re: Bug#232448: debian-policy: Ada Library Information files must be read-only
Date: Sat, 17 Jul 2010 18:42:17 -0700
ludovic.brenta@insalien.org writes:

> The packages gnat, gnat-3.2, gnat-3.3 and several Ada library packages
> provide Ada Library Information (*.ali) files to accompany the compiled
> (static and shared) libraries.  The Ada compiler requires these files to
> be read-only for all users; otherwise, it tries to recompile the
> corresponding source files, and fails because it cannot place the object
> files in the same directory as the *.ali files.

> The Policy should state that all packages that install *.ali files must
> ensure they are read-only for all users.  For now, the Ada packages use
> post-installation scripts for this, thus bypassing checks made by
> lintian and linda.  See bugs #226879 and #227162.

> I propose the following addition to Section 8.4 "Development files":

> "If the package provides Ada Library Information (*.ali) files for use
> with GNAT, these files must be read-only for all users."

About six years ago, you filed this bug against Policy, and I see there's
also a Lintian check:

Tag: bad-permissions-for-ali-file
Severity: normal
Certainty: certain
Info: Ada Library Information (*.ali) files are required to be read-only
 (mode 0444) by GNAT. 
 .
 If at least one user can write the *.ali file, GNAT considers whether
 or not to recompile the corresponding source file.  Such recompilation
 would fail because normal users don't have write permission on the
 files.  Moreover, such recompilation would defeat the purpose of
 library packages, which provide *.a and *.so libraries to link against).

I wanted to double-check with you that this requirement is still the case
before proposing the Policy patch given how much time has gone by.  Is
this still current and correct information?

-- 
Russ Allbery (rra@debian.org)               <http://www.eyrie.org/~eagle/>




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#232448; Package debian-policy. (Sun, 18 Jul 2010 07:12:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ludovic Brenta <ludovic@ludovic-brenta.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. (Sun, 18 Jul 2010 07:12:03 GMT) Full text and rfc822 format available.

Message #49 received at 232448@bugs.debian.org (full text, mbox):

From: Ludovic Brenta <ludovic@ludovic-brenta.org>
To: Russ Allbery <rra@debian.org>
Cc: 232448@bugs.debian.org
Subject: Re: Bug#232448: debian-policy: Ada Library Information files must be read-only
Date: Sun, 18 Jul 2010 09:03:03 +0200
Yes, the information is still current and correct.  (One does not change
a sound design decision that has proven its worth for years... :) )

-- 
Ludovic Brenta.




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#232448; Package debian-policy. (Mon, 19 Jul 2010 16:36:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Russ Allbery <rra@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. (Mon, 19 Jul 2010 16:36:03 GMT) Full text and rfc822 format available.

Message #54 received at 232448@bugs.debian.org (full text, mbox):

From: Russ Allbery <rra@debian.org>
To: Ludovic Brenta <ludovic@ludovic-brenta.org>
Cc: 232448@bugs.debian.org
Subject: Re: Bug#232448: debian-policy: Ada Library Information files must be read-only
Date: Mon, 19 Jul 2010 09:34:13 -0700
Ludovic Brenta <ludovic@ludovic-brenta.org> writes:

> Yes, the information is still current and correct.  (One does not change
> a sound design decision that has proven its worth for years... :) )

Okay, here is a proposed patch which implements the request in this bug
report.  Objections or seconds?

diff --git a/policy.sgml b/policy.sgml
index 6943397..3a70475 100644
--- a/policy.sgml
+++ b/policy.sgml
@@ -5389,6 +5389,14 @@ Replaces: mail-transport-agent
 	(<prgn>ld</prgn>) when compiling packages, as it will only look for
 	<file>libgdbm.so</file> when compiling dynamically.
       </p>
+
+      <p>
+	If the package provides Ada Library Information
+	(<file>*.ali</file>) files for use with GNAT, these files must be
+	installed read-only (mode 0444) so that GNAT will not attempt to
+	recompile them.  This overrides the normal file mode requirements
+	given in <ref id="permissions-owners">.
+      </p>
       </sect>
 
       <sect id="sharedlibs-intradeps">
@@ -7946,7 +7954,7 @@ endscript
 	</p>
       </sect>
 
-      <sect>
+      <sect id="permissions-owners">
 	<heading>Permissions and owners</heading>
 
 	<p>

-- 
Russ Allbery (rra@debian.org)               <http://www.eyrie.org/~eagle/>




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#232448; Package debian-policy. (Mon, 19 Jul 2010 16:42:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Emilio Pozuelo Monfort <pochu@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. (Mon, 19 Jul 2010 16:42:04 GMT) Full text and rfc822 format available.

Message #59 received at 232448@bugs.debian.org (full text, mbox):

From: Emilio Pozuelo Monfort <pochu@debian.org>
To: Russ Allbery <rra@debian.org>, 232448@bugs.debian.org
Subject: Re: Bug#232448: debian-policy: Ada Library Information files must be read-only
Date: Mon, 19 Jul 2010 18:38:20 +0200
Hi,

On 19/07/10 18:34, Russ Allbery wrote:
> diff --git a/policy.sgml b/policy.sgml
> index 6943397..3a70475 100644
> --- a/policy.sgml
> +++ b/policy.sgml
> @@ -5389,6 +5389,14 @@ Replaces: mail-transport-agent
>  	(<prgn>ld</prgn>) when compiling packages, as it will only look for
>  	<file>libgdbm.so</file> when compiling dynamically.
>        </p>
> +
> +      <p>
> +	If the package provides Ada Library Information
> +	(<file>*.ali</file>) files for use with GNAT, these files must be
> +	installed read-only (mode 0444) so that GNAT will not attempt to
> +	recompile them.  This overrides the normal file mode requirements
> +	given in <ref id="permissions-owners">.
> +      </p>
>        </sect>
>  
>        <sect id="sharedlibs-intradeps">
> @@ -7946,7 +7954,7 @@ endscript
>  	</p>
>        </sect>
>  
> -      <sect>
> +      <sect id="permissions-owners">
>  	<heading>Permissions and owners</heading>
>  
>  	<p>
> 

Seconded.

Emilio




Added tag(s) patch. Request was from Russ Allbery <rra@debian.org> to control@bugs.debian.org. (Mon, 19 Jul 2010 17:42:03 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#232448; Package debian-policy. (Mon, 19 Jul 2010 19:57:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ludovic Brenta <ludovic@ludovic-brenta.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. (Mon, 19 Jul 2010 19:57:03 GMT) Full text and rfc822 format available.

Message #66 received at 232448@bugs.debian.org (full text, mbox):

From: Ludovic Brenta <ludovic@ludovic-brenta.org>
To: <232448@bugs.debian.org>
Cc: Russ Allbery <rra@debian.org>
Subject: Bug#232448: debian-policy: Ada Library Information files must be read-only
Date: Mon, 19 Jul 2010 21:49:15 +0200
Russ Allbery <rra@debian.org> writes:

> Ludovic Brenta <ludovic@ludovic-brenta.org> writes:

>

>> Yes, the information is still current and correct.  (One does not

change

>> a sound design decision that has proven its worth for years... :) )

>

> Okay, here is a proposed patch which implements the request in this bug

> report.  Objections or seconds?

>

> diff --git a/policy.sgml b/policy.sgml

> index 6943397..3a70475 100644

> --- a/policy.sgml

> +++ b/policy.sgml

> @@ -5389,6 +5389,14 @@ Replaces: mail-transport-agent

>  	(<prgn>ld</prgn>) when compiling packages, as it will only look for

>  	<file>libgdbm.so</file> when compiling dynamically.

>        </p>

> +

> +      <p>

> +	If the package provides Ada Library Information

> +	(<file>*.ali</file>) files for use with GNAT, these files must be

> +	installed read-only (mode 0444) so that GNAT will not attempt to

> +	recompile them.  This overrides the normal file mode requirements

> +	given in <ref id="permissions-owners">.

> +      </p>

>        </sect>

>  

>        <sect id="sharedlibs-intradeps">

> @@ -7946,7 +7954,7 @@ endscript

>  	</p>

>        </sect>

>  

> -      <sect>

> +      <sect id="permissions-owners">

>  	<heading>Permissions and owners</heading>

>  

>  	<p>





Seconded.  I think my second is worth a lot because I'm the principal

maintainer and coordinator of Ada in Debian, as well as the main author

of the Debian Ada Policy.



-- 

Ludovic Brenta.






Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#232448; Package debian-policy. (Sun, 25 Jul 2010 04:00:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Russ Allbery <rra@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. (Sun, 25 Jul 2010 04:00:03 GMT) Full text and rfc822 format available.

Message #71 received at 232448@bugs.debian.org (full text, mbox):

From: Russ Allbery <rra@debian.org>
To: 232448@bugs.debian.org
Cc: Ludovic Brenta <ludovic@ludovic-brenta.org>
Subject: Re: Bug#232448: debian-policy: Ada Library Information files must be read-only
Date: Sat, 24 Jul 2010 20:58:37 -0700
Russ Allbery <rra@debian.org> writes:
> Ludovic Brenta <ludovic@ludovic-brenta.org> writes:

>> Yes, the information is still current and correct.  (One does not change
>> a sound design decision that has proven its worth for years... :) )

> Okay, here is a proposed patch which implements the request in this bug
> report.  Objections or seconds?

This change has now been merged for the next release.

-- 
Russ Allbery (rra@debian.org)               <http://www.eyrie.org/~eagle/>




Added tag(s) pending; removed tag(s) patch. Request was from Russ Allbery <rra@debian.org> to control@bugs.debian.org. (Sun, 25 Jul 2010 04:00:04 GMT) Full text and rfc822 format available.

Reply sent to Russ Allbery <rra@debian.org>:
You have taken responsibility. (Mon, 26 Jul 2010 05:06:12 GMT) Full text and rfc822 format available.

Notification sent to ludovic@ludovic-brenta.org:
Bug acknowledged by developer. (Mon, 26 Jul 2010 05:06:12 GMT) Full text and rfc822 format available.

Message #78 received at 232448-close@bugs.debian.org (full text, mbox):

From: Russ Allbery <rra@debian.org>
To: 232448-close@bugs.debian.org
Subject: Bug#232448: fixed in debian-policy 3.9.1.0
Date: Mon, 26 Jul 2010 05:02:06 +0000
Source: debian-policy
Source-Version: 3.9.1.0

We believe that the bug you reported is fixed in the latest version of
debian-policy, which is due to be installed in the Debian FTP archive:

debian-policy_3.9.1.0.dsc
  to main/d/debian-policy/debian-policy_3.9.1.0.dsc
debian-policy_3.9.1.0.tar.gz
  to main/d/debian-policy/debian-policy_3.9.1.0.tar.gz
debian-policy_3.9.1.0_all.deb
  to main/d/debian-policy/debian-policy_3.9.1.0_all.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 232448@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Russ Allbery <rra@debian.org> (supplier of updated debian-policy package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Sun, 25 Jul 2010 19:38:21 -0700
Source: debian-policy
Binary: debian-policy
Architecture: source all
Version: 3.9.1.0
Distribution: unstable
Urgency: low
Maintainer: Debian Policy List <debian-policy@lists.debian.org>
Changed-By: Russ Allbery <rra@debian.org>
Description: 
 debian-policy - Debian Policy Manual and related documents
Closes: 104373 175202 184064 186102 218897 232448 400322 402721 436105 445203 475101 477240 509932 509933 555977 561413 588750 589362 589605 589609
Changes: 
 debian-policy (3.9.1.0) unstable; urgency=low
 .
   * Policy: Include GPL version 1 in common-licenses
     Wording: Russ Allbery <rra@debian.org>
     Seconded: gregor herrmann <gregoa@debian.org>
     Seconded: Damyan Ivanov <dmn@debian.org>
     Seconded: Giacomo A. Catenazzi <cate@debian.org>
     Closes: #436105
   * Policy: Libtool *.la files should generally not be installed
     Wording: Russ Allbery <rra@debian.org>
     Seconded: Julien Cristau <jcristau@debian.org>
     Seconded: Cyril Brulebois <kibi@debian.org>
     Closes: #561413
   * Policy: Require dpkg-divert --package when adding/removing diversions
     Wording: Russ Allbery <rra@debian.org>
     Seconded: Raphaël Hertzog <hertzog@debian.org>
     Seconded: Raphael Geissert <geissert@debian.org>
     Closes: #218897
   * Policy: Remove encouragement to create shlibs.local
     Wording: Russ Allbery <rra@debian.org>
     Seconded: Julien Cristau <jcristau@debian.org>
     Seconded: Jakub Wilk <jwilk@debian.org>
     Seconded: Cyril Brulebois <kibi@debian.org>
   * Policy: Document alternate SONAME format with version before .so
     Wording: Russ Allbery <rra@debian.org>
     Seconded: Julien Cristau <jcristau@debian.org>
     Seconded: Raphaël Hertzog <hertzog@debian.org>
     Closes: #509932
   * Policy: Architecture wildcards also allowed in binary relationships
     Wording: Russ Allbery <rra@debian.org>
     Seconded: Guillem Jover <guillem@debian.org>
     Seconded: Raphaël Hertzog <hertzog@debian.org>
     Closes: #400322
   * Policy: Say Conflicts should not be used unless necessary
     Wording: Russ Allbery <rra@debian.org>
     Seconded: Guillem Jover <guillem@debian.org>
     Seconded: Jakub Wilk <jwilk@debian.org>
     Closes: #402721
   * Policy: Remove obsolete _REENTRANT, require thread-safe libraries
     Wording: Russ Allbery <rra@debian.org>
     Seconded: Kurt Roeckx <kurt@roeckx.be>
     Seconded: Giacomo A. Catenazzi <cate@debian.org>
     Closes: #475101
   * Policy: Allow subdirectories of /usr/lib/cgi-bin to be used
     Wording: Russ Allbery <rra@debian.org>
     Seconded: Andrew McMillan <andrew@morphoss.com>
     Seconded: Charles Plessy <plessy@debian.org>
     Closes: #104373
   * Policy: More specific requirements around date-based versions
     Wording: Russ Allbery <rra@debian.org>
     Seconded: Julien Cristau <jcristau@debian.org>
     Seconded: Cyril Brulebois <kibi@debian.org>
     Seconded: Steve Langasek <vorlon@debian.org>
     Closes: #186102
   * Policy: Require slave alternatives for manual pages
     Wording: Russ Allbery <rra@debian.org>
     Seconded: Guillem Jover <guillem@debian.org>
     Seconded: Jakub Wilk <jwilk@debian.org>
     Seconded: Emilio Pozuelo Monfort <pochu@debian.org>
     Closes: #184064
   * Policy: More explicit requirements around library SONAMEs
     Wording: Russ Allbery <rra@debian.org>
     Seconded: Raphaël Hertzog <hertzog@debian.org>
     Seconded: Emilio Pozuelo Monfort <pochu27@gmail.com>
     Closes: #509933
   * Policy: Only dpkg-gencontrol supports variable substitutions
     Wording: Charles Plessy <plessy@debian.org>
     Seconded: Emilio Pozuelo Monfort <pochu@debian.org>
     Seconded: Guillem Jover <guillem@debian.org>
     Closes: #589609
   * Policy: Ada Library Information files must be read-only
     Wording: Russ Allbery <rra@debian.org>
     Seconded: Emilio Pozuelo Monfort <pochu@debian.org>
     Seconded: Ludovic Brenta <ludovic@ludovic-brenta.org>
     Closes: #232448
   * Policy: Recommend /etc/logrotate.d/package for logrotate rules
     Wording: Russ Allbery <rra@debian.org>
     Seconded: Guillem Jover <guillem@debian.org>
     Seconded: Thijs Kinkhorst <thijs@debian.org>
     Closes: #445203
   * Policy: Allow /bin/sh scripts to rely on XSI for kill and trap
     Wording: Russ Allbery <rra@debian.org>
     Seconded: Giacomo A. Catenazzi <cate@debian.org>
     Seconded: Raphael Geissert <geissert@debian.org>
     Closes: #477240
   * Policy: Ownership and permissions for control information files
     Wording: Russ Allbery <rra@debian.org>
     Seconded: Emilio Pozuelo Monfort <pochu@debian.org>
     Seconded: Julien Cristau <jcristau@debian.org>
     Closes: #555977
   * Set the version of the Perl Policy to match the version of the Policy
     package.
   * Explain the Perl module package naming policy more explicitly and
     provide some examples.  (Closes: #175202)
   * Revise the footnote discussing shlibs creation to not talk about the
     switch to objdump as if it were a new innovation and to explicitly
     mention the NEEDED attribute as the source of dependency information.
   * Introduce "control information file" to refer to the contents of the
     Debian package control.tar.gz, following the dpkg documentation.  Use
     that terminology consistently, and change possibly confusing
     references to fields in control files to use "control field"
     uniformly.
   * Document that the first line of the changelog entry is conventionally
     an explanation for the upload if the uploader is not the regular
     maintainer.  Patch from Charles Plessy.  (Closes: #589605)
   * Fix typo in upgrading-checklist.  (Closes: #588750)
   * Fix formatting error in footnote to 7.7.  (Closes: #589362)
   * Remove ancient Conflicts and Replaces.
Checksums-Sha1: 
 1dc24a34db96f2c812fc560281cd3460256f72e7 1204 debian-policy_3.9.1.0.dsc
 af1c2192f6fc3c241618b48688f4d714aa630da2 690539 debian-policy_3.9.1.0.tar.gz
 1a94fda2ee6ad584efc2dab420178b993b028545 1852358 debian-policy_3.9.1.0_all.deb
Checksums-Sha256: 
 e81bc2f72659dd75a94ee4b6ba3dfe26ddf09811ece2e00cf2ebf9372ca68b98 1204 debian-policy_3.9.1.0.dsc
 7322f07e9bcd80dc3379f2545e7be7b93a2dc48b30b490b6277082024d98e847 690539 debian-policy_3.9.1.0.tar.gz
 facfbcbc037f7fb768cb9a42f72da3bff750922b8828fce633cc400012a71744 1852358 debian-policy_3.9.1.0_all.deb
Files: 
 10aae2bd3a3c14fb6853f26b9b97de55 1204 doc optional debian-policy_3.9.1.0.dsc
 3a8ac906da51c3574c6e92aa6c12af8e 690539 doc optional debian-policy_3.9.1.0.tar.gz
 182e7d0f26b29101150014c9bd2fa8eb 1852358 doc optional debian-policy_3.9.1.0_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.10 (GNU/Linux)

iEYEARECAAYFAkxNE9EACgkQ+YXjQAr8dHZzsACg2tBvXhJKJNRtTDg2XwJdG1es
RzcAoI2YCA0+mnxQa4QapbxlH44szEML
=8Iyg
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Thu, 02 Sep 2010 07:34:25 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Wed Apr 16 20:01:13 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.